FUNCTION query_sql_str2, query, struct, use_my_struct=use_my_struct

;first perform query
csv_result=query_sql(query)

;check whether query returned any rows
if n_elements(csv_result) eq 1 then return,'Query Failed'
print,'Database returned: '+strmid(csv_result[0],1)

datastart = (where(strmid(csv_result, 0,1) ne '#'))(0)

if datastart eq -1 then return, ''
if datastart+1 eq n_elements(csv_result) then return, ''

n_records = n_elements(csv_result)-datastart - 1l ; JB added "-1l"
fieldnames = STRSPLIT(csv_result[datastart], ',', /extract)
n_fields=n_elements(fieldnames)

; begin modif JB
if keyword_set(use_my_struct) then begin 
    result = replicate(struct,n_records)
endif else begin 
    sample_data = strsplit(csv_result[datastart+1], ',', /extract)
   ;create structure
    q_fn="'"+fieldnames+"'"
   ;check for spaces in data, which need to be changed to struct
    for i=0, n_elements(sample_data)-1 do if (strpos(sample_data[i], ' ') ne -1 $
      OR STREGEX(sample_data[i], '[a-z]', /FOLD_CASE) ne -1) $
      AND  strmid(sample_data[i], 0, 1) ne "'" then $
      sample_data[i]="'"+sample_data[i]+"'" 

    big_box_str=transpose([[q_fn], [sample_data]])
    big_line_str=strjoin(strjoin(big_box_str, ', '), ', ')
    comm = 'res=create_struct('+big_line_str+')'
    ro   = execute(comm)
    print,'Parsing a search returning ' + string(n_records) + ' lines'
    result = replicate(res, n_records)
endelse
; en modif JB

for i=1l, n_records do begin          ; JB : removed "-1" consistently with above change ... 
    vals=strsplit(csv_result[datastart+i], ',', /extract)
    for j=0,n_fields-1 do result[i-1].(j) = vals[j]    ; JB : result[i] -> result[i-1] so that the array starts at 0 ... 
endfor

print,'n_records = '+strtrim(n_records,2)

return, result
	
END








